diff --git a/ui/include/classes/ldap/CLdap.php b/ui/include/classes/ldap/CLdap.php
index 5161ada9b9f..fb3be4e0865 100644
--- a/ui/include/classes/ldap/CLdap.php
+++ b/ui/include/classes/ldap/CLdap.php
@@ -31,6 +31,29 @@ class CLdap {
 	const ERR_OPT_REFERRALS_FAILED = 12;
 	const ERR_OPT_DEREF_FAILED = 13;
 
+	/**
+	 * @var array $cnf  LDAP connection settings.
+	 */
+	private $cnf = [
+		'host'				=> '',
+		'port'				=> '',
+		'bind_dn'			=> '',
+		'bind_password'		=> '',
+		'base_dn'			=> '',
+		'search_attribute'	=> '',
+		'search_filter'		=> '',
+		'groupkey'			=> 'cn',
+		'mapping'			=> [
+			'username' => 'uid',
+			'userid' => 'uidnumbera',
+			'passwd' => 'userpassword'
+		],
+		'referrals'			=> 0,
+		'version'			=> 3,
+		'start_tls'			=> ZBX_AUTH_START_TLS_OFF,
+		'deref' => null
+	];
+
 	/**
 	 * @var int
 	 */
@@ -39,30 +62,15 @@ class CLdap {
 	public function __construct($arg = []) {
 		$this->ds = false;
 		$this->info = [];
-		$this->cnf = [
-			'host' => 'ldap://localhost',
-			'port' => '389',
-			'bind_dn' => 'uid=admin,ou=system',
-			'bind_password' => '',
-			'base_dn' => 'ou=users,ou=system',
-			'search_attribute' => 'uid',
-			'userfilter' => '(%{attr}=%{user})',
-			'groupkey' => 'cn',
-			'mapping' => [
-				'username' => 'uid',
-				'userid' => 'uidnumbera',
-				'passwd' => 'userpassword'
-			],
-			'referrals' => 0,
-			'version' => 3,
-			'starttls' => null,
-			'deref' => null
-		];
 
 		if (is_array($arg)) {
 			$this->cnf = zbx_array_merge($this->cnf, $arg);
 		}
 
+		if ($this->cnf['search_filter'] === '') {
+			$this->cnf['search_filter'] = '(%{attr}=%{user})';
+		}
+
 		$this->error = $this->moduleEnabled() ? 0 : static::ERR_PHP_EXTENSION;
 	}
 
@@ -100,7 +108,7 @@ class CLdap {
 			}
 			else {
 				// use TLS (needs version 3)
-				if (isset($this->cnf['starttls']) && !@ldap_start_tls($this->ds)) {
+				if ($this->cnf['start_tls'] && !@ldap_start_tls($this->ds)) {
 					$this->error = static::ERR_OPT_TLS_FAILED;
 				}
 
@@ -144,7 +152,7 @@ class CLdap {
 
 			$this->bound = 2;
 		}
-		elseif (!empty($this->cnf['bind_dn']) && !empty($this->cnf['base_dn']) && !empty($this->cnf['userfilter'])) {
+		elseif (!empty($this->cnf['bind_dn']) && !empty($this->cnf['base_dn']) && !empty($this->cnf['search_filter'])) {
 			// special bind string
 			$dn = $this->makeFilter($this->cnf['bind_dn'], ['user' => $user, 'host' => $this->cnf['host']]);
 		}
@@ -217,13 +225,7 @@ class CLdap {
 
 		// get info for given user
 		$base = $this->makeFilter($this->cnf['base_dn'], $info);
-
-		if (isset($this->cnf['userfilter']) && !empty($this->cnf['userfilter'])) {
-			$filter = $this->makeFilter($this->cnf['userfilter'], $info);
-		}
-		else {
-			$filter = '(ObjectClass=*)';
-		}
+		$filter = $this->makeFilter($this->cnf['search_filter'], $info);
 		$sr = @ldap_search($this->ds, $base, $filter);
 		$result = is_resource($sr) ? @ldap_get_entries($this->ds, $sr) : [];
 
diff --git a/ui/include/classes/mvc/CRouter.php b/ui/include/classes/mvc/CRouter.php
index 591be2aa675..d46a09dbbef 100644
--- a/ui/include/classes/mvc/CRouter.php
+++ b/ui/include/classes/mvc/CRouter.php
@@ -171,6 +171,10 @@ class CRouter {
 		'popup.itemtest.edit'						=> ['CControllerPopupItemTestEdit',						'layout.json',			'popup.itemtestedit.view'],
 		'popup.itemtest.getvalue'					=> ['CControllerPopupItemTestGetValue',					'layout.json',			null],
 		'popup.itemtest.send'						=> ['CControllerPopupItemTestSend',						'layout.json',			null],
+		'popup.ldap.check'							=> ['CControllerPopupLdapCheck',						'layout.json',			null],
+		'popup.ldap.edit'							=> ['CControllerPopupLdapEdit',							'layout.json',			'popup.ldap.edit'],
+		'popup.ldap.test.edit'						=> ['CControllerPopupLdapTestEdit',						'layout.json',			'popup.ldap.test.edit'],
+		'popup.ldap.test.send'						=> ['CControllerPopupLdapTestSend',						'layout.json',			null],
 		'popup.lldoperation'						=> ['CControllerPopupLldOperation',						'layout.json',			'popup.lldoperation'],
 		'popup.lldoverride'							=> ['CControllerPopupLldOverride',						'layout.json',			'popup.lldoverride'],
 		'popup.maintenance.period'					=> ['CControllerPopupMaintenancePeriod',				'layout.json',			'popup.maintenance.period'],
diff --git a/ui/include/defines.inc.php b/ui/include/defines.inc.php
index f6c273f4772..7221924ae50 100644
--- a/ui/include/defines.inc.php
+++ b/ui/include/defines.inc.php
@@ -22,7 +22,7 @@ define('ZABBIX_VERSION',		'6.0.4rc1');
 define('ZABBIX_API_VERSION',	'6.0.4');
 define('ZABBIX_EXPORT_VERSION',	'6.0');
 
-define('ZABBIX_DB_VERSION',		6000000);
+define('ZABBIX_DB_VERSION',		6000015);
 
 define('DB_VERSION_SUPPORTED',				0);
 define('DB_VERSION_LOWER_THAN_MINIMUM',		1);
@@ -138,6 +138,8 @@ define('ZBX_AUTH_FORM_ZABBIX',	0);
 define('ZBX_AUTH_FORM_HTTP',	1);
 define('ZBX_AUTH_CASE_INSENSITIVE',	0);
 define('ZBX_AUTH_CASE_SENSITIVE',	1);
+define('ZBX_AUTH_START_TLS_OFF',	0);
+define('ZBX_AUTH_START_TLS_ON',		1);
 
 // password policy
 define('PASSWD_CHECK_CASE', 0x01);
@@ -2041,6 +2043,7 @@ define('ZBX_STYLE_ZABBIX_LOGO', 'zabbix-logo');
 define('ZBX_STYLE_ZABBIX_SIDEBAR_LOGO', 'zabbix-sidebar-logo');
 define('ZBX_STYLE_ZABBIX_SIDEBAR_LOGO_COMPACT', 'zabbix-sidebar-logo-compact');
 define('ZBX_STYLE_WIDGET_ITEM_LABEL', 'widget-item-label');
+define('ZBX_STYLE_DEFAULT_OPTION', 'default-option');
 
 // HTML column layout.
 define('ZBX_STYLE_COLUMNS', 'columns-wrapper');
diff --git a/ui/include/schema.inc.php b/ui/include/schema.inc.php
index 4730c6d22fc..b9f7bf35b47 100644
--- a/ui/include/schema.inc.php
+++ b/ui/include/schema.inc.php
@@ -1555,6 +1555,14 @@ return [
 				'type' => DB::FIELD_TYPE_INT,
 				'length' => 10,
 				'default' => '0'
+			],
+			'userdirectoryid' => [
+				'null' => true,
+				'type' => DB::FIELD_TYPE_ID,
+				'length' => 20,
+				'default' => NULL,
+				'ref_table' => 'userdirectory',
+				'ref_field' => 'userdirectoryid'
 			]
 		]
 	],
@@ -2148,42 +2156,6 @@ return [
 				'length' => 10,
 				'default' => '0'
 			],
-			'ldap_host' => [
-				'null' => false,
-				'type' => DB::FIELD_TYPE_CHAR,
-				'length' => 255,
-				'default' => ''
-			],
-			'ldap_port' => [
-				'null' => false,
-				'type' => DB::FIELD_TYPE_INT,
-				'length' => 10,
-				'default' => 389
-			],
-			'ldap_base_dn' => [
-				'null' => false,
-				'type' => DB::FIELD_TYPE_CHAR,
-				'length' => 255,
-				'default' => ''
-			],
-			'ldap_bind_dn' => [
-				'null' => false,
-				'type' => DB::FIELD_TYPE_CHAR,
-				'length' => 255,
-				'default' => ''
-			],
-			'ldap_bind_password' => [
-				'null' => false,
-				'type' => DB::FIELD_TYPE_CHAR,
-				'length' => 128,
-				'default' => ''
-			],
-			'ldap_search_attribute' => [
-				'null' => false,
-				'type' => DB::FIELD_TYPE_CHAR,
-				'length' => 128,
-				'default' => ''
-			],
 			'discovery_groupid' => [
 				'null' => false,
 				'type' => DB::FIELD_TYPE_ID,
@@ -2807,6 +2779,14 @@ return [
 				'type' => DB::FIELD_TYPE_CHAR,
 				'length' => 1024,
 				'default' => ''
+			],
+			'ldap_userdirectoryid' => [
+				'null' => true,
+				'type' => DB::FIELD_TYPE_ID,
+				'length' => 20,
+				'default' => NULL,
+				'ref_table' => 'userdirectory',
+				'ref_field' => 'userdirectoryid'
 			]
 		]
 	],
@@ -8894,6 +8874,75 @@ return [
 			]
 		]
 	],
+	'userdirectory' => [
+		'key' => 'userdirectoryid',
+		'fields' => [
+			'userdirectoryid' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_ID,
+				'length' => 20
+			],
+			'name' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_CHAR,
+				'length' => 128,
+				'default' => ''
+			],
+			'description' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_TEXT,
+				'default' => ''
+			],
+			'host' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_CHAR,
+				'length' => 255,
+				'default' => ''
+			],
+			'port' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_INT,
+				'length' => 10,
+				'default' => 389
+			],
+			'base_dn' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_CHAR,
+				'length' => 255,
+				'default' => ''
+			],
+			'bind_dn' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_CHAR,
+				'length' => 255,
+				'default' => ''
+			],
+			'bind_password' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_CHAR,
+				'length' => 128,
+				'default' => ''
+			],
+			'search_attribute' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_CHAR,
+				'length' => 128,
+				'default' => ''
+			],
+			'start_tls' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_INT,
+				'length' => 10,
+				'default' => '0'
+			],
+			'search_filter' => [
+				'null' => false,
+				'type' => DB::FIELD_TYPE_CHAR,
+				'length' => 255,
+				'default' => ''
+			]
+		]
+	],
 	'dbversion' => [
 		'key' => 'dbversionid',
 		'fields' => [
diff --git a/ui/js/class.cmap.js b/ui/js/class.cmap.js
index 1ea88b03721..6622744373d 100644
--- a/ui/js/class.cmap.js
+++ b/ui/js/class.cmap.js
@@ -91,6 +91,7 @@ ZABBIX.namespace('apps.map');
 ZABBIX.apps.map = (function($) {
 	// dependencies
 	var Observer = ZABBIX.classes.Observer;
+	const ZBX_STYLE_DEFAULT_OPTION = 'default-option';
 
 	function createMap(containerId, mapData) {
 		var CMap = function(containerId, mapData) {
@@ -2672,9 +2673,9 @@ ZABBIX.apps.map = (function($) {
 			const select_icon_maintenance = document.getElementById('iconid_maintenance');
 			const select_icon_disabled = document.getElementById('iconid_disabled');
 
-			select_icon_on.addOption({label: t('S_DEFAULT'), value: '0'});
-			select_icon_maintenance.addOption({label: t('S_DEFAULT'), value: '0'});
-			select_icon_disabled.addOption({label: t('S_DEFAULT'), value: '0'});
+			select_icon_on.addOption({label: t('S_DEFAULT'), value: '0', class_name: ZBX_STYLE_DEFAULT_OPTION});
+			select_icon_maintenance.addOption({label: t('S_DEFAULT'), value: '0', class_name: ZBX_STYLE_DEFAULT_OPTION});
+			select_icon_disabled.addOption({label: t('S_DEFAULT'), value: '0', class_name: ZBX_STYLE_DEFAULT_OPTION});
 
 			for (i in this.sysmap.iconList) {
 				icon = this.sysmap.iconList[i];
@@ -3252,9 +3253,9 @@ ZABBIX.apps.map = (function($) {
 			const select_icon_maintenance = document.getElementById('massIconidMaintenance');
 			const select_icon_disabled = document.getElementById('massIconidDisabled');
 
-			select_icon_on.addOption({label: t('S_DEFAULT'), value: '0'});
-			select_icon_maintenance.addOption({label: t('S_DEFAULT'), value: '0'});
-			select_icon_disabled.addOption({label: t('S_DEFAULT'), value: '0'});
+			select_icon_on.addOption({label: t('S_DEFAULT'), value: '0', class_name: ZBX_STYLE_DEFAULT_OPTION});
+			select_icon_maintenance.addOption({label: t('S_DEFAULT'), value: '0', class_name: ZBX_STYLE_DEFAULT_OPTION});
+			select_icon_disabled.addOption({label: t('S_DEFAULT'), value: '0', class_name: ZBX_STYLE_DEFAULT_OPTION});
 
 			for (i in this.sysmap.iconList) {
 				icon = this.sysmap.iconList[i];
